//-------------------------------------------------------------------------
/*
Copyright (C) 1996, 2003 - 3D Realms Entertainment
Copyright (C) 2000, 2003 - Matt Saettler (EDuke Enhancements)
Copyright (C) 2004, 2005 - Richard Gobeille (EDuke32 functionality)

This file is part of Duke Nukem 3D version 1.5 - Atomic Edition

Duke Nukem 3D is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Original Source: 1996 - Todd Replogle
Prepared for public release: 03/21/2003 - Charlie Wiederhold, 3D Realms
Modifications for JonoF's port by Jonathon Fowler (jonof@edgenetwk.com)
*/
//-------------------------------------------------------------------------

#define PLAYER_ZOOM 1
#define PLAYER_EXITX 2
#define PLAYER_EXITY 3
#define PLAYER_LOOGIEX 4
#define PLAYER_LOOGIEY 5
#define PLAYER_NUMLOOGS 6
#define PLAYER_LOOGCNT 7
#define PLAYER_POSX 8
#define PLAYER_POSY 9
#define PLAYER_POSZ 10
#define PLAYER_HORIZ 11
#define PLAYER_OHORIZ 12
#define PLAYER_OHORIZOFF 13
#define PLAYER_INVDISPTIME 14
#define PLAYER_BOBPOSX 15
#define PLAYER_BOBPOSY 16
#define PLAYER_OPOSX 17
#define PLAYER_OPOSY 18
#define PLAYER_OPOSZ 19
#define PLAYER_PYOFF 20
#define PLAYER_OPYOFF 21
#define PLAYER_POSXV 22
#define PLAYER_POSYV 23
#define PLAYER_POSZV 24
#define PLAYER_LAST_PISSED_TIME 25
#define PLAYER_TRUEFZ 26
#define PLAYER_TRUECZ 27
#define PLAYER_PLAYER_PAR 28
#define PLAYER_VISIBILITY 29
#define PLAYER_BOBCOUNTER 30
#define PLAYER_WEAPON_SWAY 31
#define PLAYER_PALS_TIME 32
#define PLAYER_RANDOMFLAMEX 33
#define PLAYER_CRACK_TIME 34
#define PLAYER_AIM_MODE 35
#define PLAYER_ANG 36
#define PLAYER_OANG 37
#define PLAYER_ANGVEL 38
#define PLAYER_CURSECTNUM 39
#define PLAYER_LOOK_ANG 40
#define PLAYER_LAST_EXTRA 41
#define PLAYER_SUBWEAPON 42
#define PLAYER_AMMO_AMOUNT 43
#define PLAYER_WACKEDBYACTOR 44
#define PLAYER_FRAG 45
#define PLAYER_FRAGGEDSELF 945
#define PLAYER_CURR_WEAPON 46
#define PLAYER_LAST_WEAPON 47
#define PLAYER_TIPINCS 48
#define PLAYER_HORIZOFF 49
#define PLAYER_WANTWEAPONFIRE 50
#define PLAYER_HOLODUKE_AMOUNT 51
#define PLAYER_NEWOWNER 52
#define PLAYER_HURT_DELAY 53
#define PLAYER_HBOMB_HOLD_DELAY 54
#define PLAYER_JUMPING_COUNTER 55
#define PLAYER_AIRLEFT 56
#define PLAYER_KNEE_INCS 57
#define PLAYER_ACCESS_INCS 58
#define PLAYER_FTA 59
#define PLAYER_FTQ 60
#define PLAYER_ACCESS_WALLNUM 61
#define PLAYER_ACCESS_SPRITENUM 62
#define PLAYER_KICKBACK_PIC 63
#define PLAYER_GOT_ACCESS 64
#define PLAYER_WEAPON_ANG 65
#define PLAYER_FIRSTAID_AMOUNT 66
#define PLAYER_SOMETHINGONPLAYER 67
#define PLAYER_ON_CRANE 68
#define PLAYER_I 69
#define PLAYER_ONE_PARALLAX_SECTNUM 70
#define PLAYER_OVER_SHOULDER_ON 71
#define PLAYER_RANDOM_CLUB_FRAME 72
#define PLAYER_FIST_INCS 73
#define PLAYER_ONE_EIGHTY_COUNT 74
#define PLAYER_CHEAT_PHASE 75
#define PLAYER_DUMMYPLAYERSPRITE 76
#define PLAYER_EXTRA_EXTRA8 77
#define PLAYER_QUICK_KICK 78
#define PLAYER_HEAT_AMOUNT 79
#define PLAYER_ACTORSQU 80
#define PLAYER_TIMEBEFOREEXIT 81
#define PLAYER_CUSTOMEXITSOUND 82
#define PLAYER_WEAPRECS 83
#define PLAYER_WEAPRECCNT 84
#define PLAYER_INTERFACE_TOGGLE_FLAG 85
#define PLAYER_ROTSCRNANG 86
#define PLAYER_DEAD_FLAG 87
#define PLAYER_SHOW_EMPTY_WEAPON 88
#define PLAYER_SCUBA_AMOUNT 89
#define PLAYER_JETPACK_AMOUNT 90
#define PLAYER_STEROIDS_AMOUNT 91
#define PLAYER_SHIELD_AMOUNT 92
#define PLAYER_HOLODUKE_ON 93
#define PLAYER_PYCOUNT 94
#define PLAYER_WEAPON_POS 95
#define PLAYER_FRAG_PS 96
#define PLAYER_TRANSPORTER_HOLD 97
#define PLAYER_LAST_FULL_WEAPON 98
#define PLAYER_FOOTPRINTSHADE 99
#define PLAYER_BOOT_AMOUNT 100
#define PLAYER_SCREAM_VOICE 101
#define PLAYER_GM 102
#define PLAYER_ON_WARPING_SECTOR 103
#define PLAYER_FOOTPRINTCOUNT 104
#define PLAYER_HBOMB_ON 105
#define PLAYER_JUMPING_TOGGLE 106
#define PLAYER_RAPID_FIRE_HOLD 107
#define PLAYER_ON_GROUND 108
#define PLAYER_NAME 109
#define PLAYER_INVEN_ICON 110
#define PLAYER_BUTTONPALETTE 111
#define PLAYER_JETPACK_ON 112
#define PLAYER_SPRITEBRIDGE 113
#define PLAYER_LASTRANDOMSPOT 114
#define PLAYER_SCUBA_ON 115
#define PLAYER_FOOTPRINTPAL 116
#define PLAYER_HEAT_ON 117
#define PLAYER_HOLSTER_WEAPON 118
#define PLAYER_FALLING_COUNTER 119
#define PLAYER_GOTWEAPON 120
#define PLAYER_REFRESH_INVENTORY 121
#define PLAYER_PALETTE 122
#define PLAYER_TOGGLE_KEY_FLAG 123
#define PLAYER_KNUCKLE_INCS 124
#define PLAYER_WALKING_SND_TOGGLE 125
#define PLAYER_PALOOKUP 126
#define PLAYER_HARD_LANDING 127
#define PLAYER_MAX_SECRET_ROOMS 128
#define PLAYER_SECRET_ROOMS 129
#define PLAYER_PALS 130
#define PLAYER_MAX_ACTORS_KILLED 131
#define PLAYER_ACTORS_KILLED 132
#define PLAYER_RETURN_TO_CENTER 133
#define PLAYER_RUNSPEED 134
#define PLAYER_SBS 135
#define PLAYER_RELOADING 136
#define PLAYER_AUTO_AIM 137
#define PLAYER_MOVEMENT_LOCK 138
#define PLAYER_SOUND_PITCH 139

#define USERDEFS_GOD 2
#define USERDEFS_WARP_ON 3
#define USERDEFS_CASHMAN 4
#define USERDEFS_EOG 5
#define USERDEFS_SHOWALLMAP 6
#define USERDEFS_SHOW_HELP 7
#define USERDEFS_SCROLLMODE 8
#define USERDEFS_CLIPPING 9
#define USERDEFS_USER_NAME 10
#define USERDEFS_RIDECULE 11
#define USERDEFS_SAVEGAME 12
#define USERDEFS_PWLOCKOUT 13
#define USERDEFS_RTSNAME 14
#define USERDEFS_OVERHEAD_ON 15
#define USERDEFS_LAST_OVERHEAD 16
#define USERDEFS_SHOWWEAPONS 17
#define USERDEFS_PAUSE_ON 18
#define USERDEFS_FROM_BONUS 19
#define USERDEFS_CAMERASPRITE 20
#define USERDEFS_LAST_CAMSPRITE 21
#define USERDEFS_LAST_LEVEL 22
#define USERDEFS_SECRETLEVEL 23
#define USERDEFS_CONST_VISIBILITY 24
#define USERDEFS_UW_FRAMERATE 25
#define USERDEFS_CAMERA_TIME 26
#define USERDEFS_FOLFVEL 27
#define USERDEFS_FOLAVEL 28
#define USERDEFS_FOLX 29
#define USERDEFS_FOLY 30
#define USERDEFS_FOLA 31
#define USERDEFS_RECCNT 32
#define USERDEFS_ENTERED_NAME 33
#define USERDEFS_SCREEN_TILTING 34
#define USERDEFS_SHADOWS 35
#define USERDEFS_FTA_ON 36
#define USERDEFS_EXECUTIONS 37
#define USERDEFS_AUTO_RUN 38
#define USERDEFS_COORDS 39
#define USERDEFS_TICKRATE 40
#define USERDEFS_M_COOP 41
#define USERDEFS_COOP 42
#define USERDEFS_SCREEN_SIZE 43
#define USERDEFS_LOCKOUT 44
#define USERDEFS_CROSSHAIR 45
#define USERDEFS_WCHOICE 46
#define USERDEFS_PLAYERAI 47
#define USERDEFS_RESPAWN_MONSTERS 48
#define USERDEFS_RESPAWN_ITEMS 49
#define USERDEFS_RESPAWN_INVENTORY 50
#define USERDEFS_RECSTAT 51
#define USERDEFS_MONSTERS_OFF 52
#define USERDEFS_BRIGHTNESS 53
#define USERDEFS_M_RESPAWN_ITEMS 54
#define USERDEFS_M_RESPAWN_MONSTERS 55
#define USERDEFS_M_RESPAWN_INVENTORY 56
#define USERDEFS_M_RECSTAT 57
#define USERDEFS_M_MONSTERS_OFF 58
#define USERDEFS_DETAIL 59
#define USERDEFS_M_FFIRE 60
#define USERDEFS_FFIRE 61
#define USERDEFS_M_PLAYER_SKILL 62
#define USERDEFS_M_LEVEL_NUMBER 63
#define USERDEFS_M_VOLUME_NUMBER 64
#define USERDEFS_MULTIMODE 65
#define USERDEFS_PLAYER_SKILL 66
#define USERDEFS_LEVEL_NUMBER 67
#define USERDEFS_VOLUME_NUMBER 68
#define USERDEFS_M_MARKER 69
#define USERDEFS_MARKER 70
#define USERDEFS_MOUSEFLIP 71
#define USERDEFS_STATUSBARSCALE 72

#define SECTOR_WALLPTR	1
#define SECTOR_WALLNUM	2
#define SECTOR_CEILINGZ	3
#define SECTOR_FLOORZ	4
#define SECTOR_CEILINGSTAT	5
#define SECTOR_FLOORSTAT	6
#define SECTOR_CEILINGPICNUM 7
#define SECTOR_CEILINGSLOPE 8
#define SECTOR_CEILINGSHADE 9
#define SECTOR_CEILINGPAL 10
#define SECTOR_CEILINGXPANNING 11
#define SECTOR_CEILINGYPANNING 12
#define SECTOR_FLOORPICNUM 13
#define SECTOR_FLOORSLOPE 14
#define SECTOR_FLOORSHADE 15
#define SECTOR_FLOORPAL 16
#define SECTOR_FLOORXPANNING 17
#define SECTOR_FLOORYPANNING 18
#define SECTOR_VISIBILITY 19
#define SECTOR_ALIGNTO 20
#define SECTOR_LOTAG 21
#define SECTOR_HITAG 22
#define SECTOR_EXTRA 23

#define WALL_X 1
#define WALL_Y 2
#define WALL_POINT2 3
#define WALL_NEXTWALL 4
#define WALL_NEXTSECTOR 5
#define WALL_CSTAT 6
#define WALL_PICNUM 7
#define WALL_OVERPICNUM 8
#define WALL_SHADE 9
#define WALL_PAL 10
#define WALL_XREPEAT 11
#define WALL_YREPEAT 12
#define WALL_XPANNING 13
#define WALL_YPANNING 14
#define WALL_LOTAG 15
#define WALL_HITAG 16
#define WALL_EXTRA 17

#define ACTOR_X 1
#define ACTOR_Y 2
#define ACTOR_Z 3
#define ACTOR_CSTAT 4
#define ACTOR_PICNUM 5
#define ACTOR_SHADE 6
#define ACTOR_PAL 7
#define ACTOR_CLIPDIST 8
#define ACTOR_DETAIL 9
#define ACTOR_XREPEAT 10
#define ACTOR_YREPEAT 11
#define ACTOR_XOFFSET 12
#define ACTOR_YOFFSET 13
#define ACTOR_SECTNUM 14
#define ACTOR_STATNUM 15
#define ACTOR_ANG 16
#define ACTOR_OWNER 17
#define ACTOR_XVEL 18
#define ACTOR_YVEL 19
#define ACTOR_ZVEL 20
#define ACTOR_LOTAG 21
#define ACTOR_HITAG 22
#define ACTOR_EXTRA 23
#define ACTOR_HTCGG 50
#define ACTOR_HTPICNUM 51
#define ACTOR_HTANG 52
#define ACTOR_HTEXTRA 53
#define ACTOR_HTOWNER 54
#define ACTOR_HTMOVFLAG 55
#define ACTOR_HTTEMPANG 56
#define ACTOR_HTACTORSTAYPUT 57
#define ACTOR_HTDISPICNUM 58
#define ACTOR_HTTIMETOSLEEP 59
#define ACTOR_HTFLOORZ 60
#define ACTOR_HTCEILINGZ 61
#define ACTOR_HTLASTVX 62
#define ACTOR_HTLASTVY 63
#define ACTOR_HTBPOSX 64
#define ACTOR_HTBPOSY 65
#define ACTOR_HTBPOSZ 66
/* #define ACTOR_HTG_T0 67
#define ACTOR_HTG_T1 68
#define ACTOR_HTG_T2 69
#define ACTOR_HTG_T3 70
#define ACTOR_HTG_T4 71
#define ACTOR_HTG_T5 72 */
#define ACTOR_HTG_T 67

#define PROJ_WORKSLIKE 1
#define PROJ_SPAWNS 2
#define PROJ_SXREPEAT 3
#define PROJ_SYREPEAT 4
#define PROJ_SOUND 5
#define PROJ_ISOUND 6
#define PROJ_VEL 7
#define PROJ_EXTRA 8
#define PROJ_DECAL 9
#define PROJ_TRAIL 10
#define PROJ_TXREPEAT 11
#define PROJ_TYREPEAT 12
#define PROJ_TOFFSET 13
#define PROJ_TNUM 14
#define PROJ_DROP 15
#define PROJ_CSTAT 16
#define PROJ_CLIPDIST 17
#define PROJ_SHADE 18
#define PROJ_XREPEAT 19
#define PROJ_YREPEAT 20
#define PROJ_PAL 21
#define PROJ_EXTRA_RAND 22
#define PROJ_HITRADIUS 23
#define PROJ_VEL_MULT 24
#define PROJ_OFFSET 25
#define PROJ_BOUNCES 26
#define PROJ_BSOUND 27
#define PROJ_RANGE 28

#define ERROR_ISAKEYWORD        1
#define ERROR_PARAMUNDEFINED     2
#define WARNING_DUPLICATEDEFINITION 3
#define ERROR_COULDNOTFIND 4
#define ERROR_VARREADONLY 5
#define ERROR_NOTAGAMEDEF 6
#define ERROR_SYMBOLNOTRECOGNIZED 7
#define ERROR_EXPECTINGKEYWORD 8
#define ERROR_NOTAGAMEVAR 9
#define ERROR_OPENBRACKET 10
#define ERROR_CLOSEBRACKET 11
#define ERROR_SYNTAXERROR 12
#define ERROR_ENHANCED 13
#define ERROR_NOENDSWITCH 14
#define ERROR_EVENTONLY 15
#define ERROR_FOUNDWITHINSTATE 16
#define ERROR_FOUNDWITHINACTOR 17
#define ERROR_VARTYPEMISMATCH 18

// keyw/parse

#define CON_GAMEVAR   			112
#define CON_IFVARL      		113
#define CON_IFVARG      		114
#define CON_SETVARVAR   		115
#define CON_SETVAR      		116
#define CON_ADDVARVAR   		117
#define CON_ADDVAR      		118
#define CON_IFVARVARL   		119
#define CON_IFVARVARG   		120
#define CON_ADDLOGVAR   		121
#define CON_ADDLOG      		122
#define CON_ONEVENT     		123
#define CON_ENDEVENT    		124
#define CON_IFVARE      		125
#define CON_IFVARVARE   		126
#define CON_SPGETLOTAG  		127
#define CON_SPGETHITAG  		128
#define CON_SECTGETLOTAG       		129
#define CON_SECTGETHITAG        	130
#define CON_IFSOUND     		131
#define CON_GETTEXTUREFLOOR     	132
#define CON_GETTEXTURECEILING   	133
#define CON_NULL 134
#define CON_STARTTRACK  135
#define CON_RANDVAR     136
#define CON_ENHANCED    137
#define CON_GETANGLETOTARGET    138
#define CON_GETACTORANGLE       139
#define CON_SETACTORANGLE       140
#define CON_MULVAR      141
#define CON_MULVARVAR   142
#define CON_DIVVAR      143
#define CON_DIVVARVAR   144
#define CON_MODVAR      145
#define CON_MODVARVAR   146
#define CON_ANDVAR      147
#define CON_ANDVARVAR   148
#define CON_ORVAR       149
#define CON_ORVARVAR    150
#define CON_GETPLAYERANGLE      151
#define CON_SETPLAYERANGLE      152
#define CON_LOCKPLAYER  153
#define CON_SETSECTOR   154
#define CON_GETSECTOR   155
#define CON_SETACTOR    156
#define CON_GETACTOR    157
#define CON_SETWALL     158
#define CON_GETWALL     159
#define CON_FINDNEARACTOR       160
#define CON_FINDNEARACTORVAR    161
#define CON_SETACTORVAR 162
#define CON_GETACTORVAR 163
#define CON_ESPAWN      164
#define CON_GETPLAYER   165
#define CON_SETPLAYER   166
#define CON_SQRT        167
#define CON_EVENTLOADACTOR      168
#define CON_ESPAWNVAR   169
#define CON_GETUSERDEF  170
#define CON_SETUSERDEF  171
#define CON_SUBVARVAR   172
#define CON_SUBVAR      173
#define CON_IFVARN      174
#define CON_IFVARVARN   175
#define CON_IFVARAND    176
#define CON_IFVARVARAND	177
#define CON_MYOS	178
#define CON_MYOSPAL	179
#define CON_DISPLAYRAND	180
#define CON_SIN	181
#define CON_XORVARVAR 182
#define CON_XORVAR	183
#define CON_RANDVARVAR 184
#define CON_MYOSX	185
#define CON_MYOSPALX 186
#define CON_GMAXAMMO 187
#define CON_SMAXAMMO 188
#define CON_STARTLEVEL 189
#define CON_ESHOOT 190
#define CON_QSPAWN 191
#define CON_ROTATESPRITE 192
#define CON_DEFINEPROJECTILE 193
#define CON_SPRITESHADOW 194
#define CON_COS 195
#define CON_ESHOOTVAR 196
#define CON_FINDNEARACTOR3D 197
#define CON_FINDNEARACTOR3DVAR 198
#define CON_FLASH 199
#define CON_QSPAWNVAR 200
#define CON_EQSPAWN 201
#define CON_EQSPAWNVAR 202
#define CON_MINITEXT 203
#define CON_GAMETEXT 204
#define CON_DIGITALNUMBER 205
#define CON_ADDWEAPONVAR 206
#define CON_SETPROJECTILE 207
#define CON_ANGOFF 208
#define CON_UPDATESECTOR 209
#define CON_INSERTSPRITEQ 210
#define CON_ANGOFFVAR 211
#define CON_WHILEVARN 212
#define CON_SWITCH 213
#define CON_CASE 214
#define CON_DEFAULT 215
#define CON_ENDSWITCH 216
#define CON_SHOOTVAR 217
#define CON_SOUNDVAR 218
#define CON_FINDPLAYER 219
#define CON_FINDOTHERPLAYER 220
#define CON_ACTIVATEBYSECTOR 221
#define CON_OPERATESECTORS 222
#define CON_OPERATERESPAWNS 223
#define CON_OPERATEACTIVATORS 224
#define CON_OPERATEMASTERSWITCHES 225
#define CON_CHECKACTIVATORMOTION 226
#define CON_ZSHOOT 227
#define CON_DIST 228
#define CON_LDIST 229
#define CON_SHIFTVARL 230
#define CON_SHIFTVARR 231
#define CON_SPRITENVG 232
#define CON_GETANGLE 233
#define CON_WHILEVARVARN 234
#define CON_HITSCAN 235
#define CON_TIME 236
#define CON_GETPLAYERVAR 237
#define CON_SETPLAYERVAR 238
#define CON_MULSCALE 239
#define CON_SETASPECT 240
#define CON_TXDIST 241
#define CON_NOSHADE 242
#define CON_MOVESPRITE 243
#define CON_CHECKAVAILWEAPON 244
#define CON_SOUNDONCEVAR 245
#define CON_UPDATESECTORZ 246
#define CON_STOPALLSOUNDS 247
#define CON_SSP 248
#define CON_STOPSOUNDVAR 249
#define CON_DISPLAYRANDVAR 250
#define CON_DISPLAYRANDVARVAR 251
#define CON_CHECKAVAILINVEN 252
#define CON_GLOBALSOUNDVAR 253
#define CON_GUNIQHUDID 254
#define CON_GETPROJECTILE 255
#define CON_GETTHISPROJECTILE 256
#define CON_SETTHISPROJECTILE 257
